#ifndef MEM_ARENA_H
#define MEM_ARENA_H

#include "aliases.h"
#include <stdbool.h>

typedef struct growing_arena Arena;

bool mem_arena_init(Arena **arena, u64 base_capacity);
void *mem_arena_alloc(Arena *arena, u64 size);
void *mem_arena_alloc_aligned(Arena *arena, u64 size, u64 alignment);
void mem_arena_clear(Arena *arena);
void mem_arena_free(Arena **arena);

#endif // !MEM_ARENA_H
